diff -uNr old/koji new/koji
--- old/koji	2010-12-09 04:20:27.989482471 -0800
+++ new/koji	2010-12-09 04:19:10.422732324 -0800
@@ -416,6 +416,40 @@
         rv = 1
     return rv
 
+# Used to print out N number of lines as defined by --lines=N 
+def lineLimit(line_counter, contents):
+    lines_in_contents = contents.split("\n")
+    
+    for l in lines_in_contents:
+        if line_counter <= 0:
+            break;
+
+        if l == "":
+            continue
+            
+        l += "\n"
+        sys.stdout.write(l)
+        line_counter -= 1
+
+    return line_counter
+    
+# Used to store the last N number of lines as defined by --tail (Default N=10)
+def circularBufferAdd(circular_buffer, line_counter, contents):
+    lines_in_contents = contents.split("\n")
+
+    for l in lines_in_contents:
+        if l == "":
+            continue
+
+        l += "\n"
+        if len(circular_buffer) < line_counter:
+            circular_buffer.append(l)
+        else:
+            circular_buffer.pop(0)
+            circular_buffer.append(l)             
+    return
+
+
 def watch_logs(session, tasklist, opts):
     global options
     print "Watching logs (this may be safely interrupted)..."
@@ -447,6 +481,9 @@
 
                 taskoffsets = offsets[task_id]
                 for log in logs:
+                    line_counter = int(opts.lines)
+                    circular_buffer = [] # Used for the --tail option
+
                     contents = 'placeholder'
                     while contents:
                         if not taskoffsets.has_key(log):
@@ -461,7 +498,21 @@
                                     sys.stdout.write("\n")
                                 sys.stdout.write("==> %s <==\n" % currlog)
                                 lastlog = currlog
-                            sys.stdout.write(contents)
+
+                            # If only the option --lines=N is set and --tail is not, then we will get N number of lines from the beginning
+                            # If --tail is set, we will get N number of lines of code from the end (default is 10 lines)
+                            if opts.lines > 0 and opts.tail == False:
+                                line_counter = lineLimit(line_counter, contents)
+                            elif opts.tail == True:
+                                circularBufferAdd(circular_buffer, line_counter, contents)             
+                            else:
+                                sys.stdout.write(contents)
+                        else:
+                            if opts.tail == True:
+                                for l in circular_buffer:
+                                    sys.stdout.write(l)
+                
+                sys.stdout.write("\n")
 
             if not tasklist:
                 break
@@ -5050,9 +5101,18 @@
     usage += _("\n(Specify the --help global option for a list of other help options)")
     parser = OptionParser(usage=usage)
     parser.add_option("--log", help=_("Watch only a specific log"))
+    parser.add_option("--lines", default = -1, help=_("Limit output to lines specified by user"))
+    parser.add_option("--tail", action="store_true", default=False, help=_("Output last part of files"))
     (options, args) = parser.parse_args(args)
     activate_session(session)
 
+    # Sets options.lines to the default of 10 lines if --lines flag is not set
+    if options.lines.isdigit() == True:
+        if options.lines <= 0:
+            options.lines = 10
+    else:
+        sys.exit(1)
+
     tasks = []
     for task in args:
         try:
